diff -Nurp '--exclude=.bzr*' tin-2.6.4/src/select.c tin-2.6.5/src/select.c
--- tin-2.6.4/src/select.c	2024-12-11 16:43:15.000000000 +0100
+++ tin-2.6.5/src/select.c	2025-12-23 03:44:49.899727710 +0100
@@ -1836,3 +2309,56 @@ get_group_from_list(
 	return found ? group : NULL;
 }
 #endif /* NNTP_ABLE */
+
+
+/* caller must free returned string */
+#ifdef NNTP_ABLE
+static char *
+nntp_list_newsgroups_grp(
+	const char *group)
+{
+	char *line, *p = NULL, *desc;
+	char cmd[NNTP_STRLEN];
+	t_bool conv_needed = FALSE;
+
+	snprintf(cmd, sizeof(cmd), "LIST NEWSGROUPS %s", group);
+	switch (new_nntp_command(cmd, OK_GROUPS, NULL, 0)) {
+		case OK_GROUPS:
+			while ((line = tin_fgets(FAKE_NNTP_FP, FALSE)) != NULL) {
+#	ifdef DEBUG
+				if (debug & DEBUG_NNTP)
+					debug_print_file("NNTP", "<<<%s%s", logtime(), line);
+#	endif /* DEBUG */
+
+				if ((p = strpbrk(line, " \t")) == NULL)
+					continue;
+
+				*p++ = '\0';
+			}
+			break;
+
+			default:
+				break;
+	}
+
+	if (p && *p) {
+		desc = my_strdup(p);
+		while (*p) {
+			if (*p == '\t')
+				*p = ' ';
+			else {
+				if (!conv_needed && (*p < 0x20 || !isascii((unsigned char) *p))) {
+					conv_needed = TRUE;
+					break;
+				}
+			}
+			++p;
+		}
+		if (conv_needed)
+			csguess_convert_str(&desc, "UTF-8");
+		str_trim(desc);
+		return desc;
+	}
+	return NULL;
+}
+#endif /* NNTP_ABLE */
diff -Nurp '--exclude=.bzr*' tin-2.6.4/src/sigfile.c tin-2.6.5/src/sigfile.c
--- tin-2.6.4/src/sigfile.c	2024-12-21 03:30:29.000000000 +0100
+++ tin-2.6.5/src/sigfile.c	2025-11-13 02:21:32.648182961 +0100
@@ -3,10 +3,10 @@
  *  Module    : sigfile.c
  *  Author    : M. Gleason & I. Lea
  *  Created   : 1992-10-17
- *  Updated   : 2024-12-21
+ *  Updated   : 2025-02-07
  *  Notes     : Generate random signature for posting/mailing etc.
  *
- * Copyright (c) 1992-2025 Mike Gleason
+ * Copyright (c) 1992-2026 Mike Gleason
  * All rights reserved.
  *
  * Redistribution and use in source and binary forms, with or without
@@ -284,14 +284,29 @@ thrashdir(
 				break;
 		}
 		if (dp != NULL) {	/* if we could open the dir entry */
-			if (!strcmp(dp->d_name, CURRENTDIR) || (dp->d_name[0] == '.'))
+			if (!strcmp(dp->d_name, CURRENTDIR) || !strncmp(dp->d_name, ".", 1) /*|| !strcmp(dp->d_name, "..")*/) /* we ignore dot-files - desired? */
 				dp = NULL;
 			else {	/* if we have a non-dot entry */
-				if (stat(dp->d_name, &st) == -1) {
+				FILE *fp;
+				int fd;
+
+				if (((fp = fopen(dp->d_name, "r")) == NULL) || ((fd = fileno(fp)) == -1)) {
+					if (fp != NULL)
+						fclose(fp);
+
+					CLOSEDIR(dirp);
+					free(cwd);
+					return 1;
+				}
+
+				if (fstat(fd, &st) == -1) {
+					fclose(fp);
 					CLOSEDIR(dirp);
 					free(cwd);
 					return 1;
 				}
+				fclose(fp);
+
 				if (S_ISDIR(st.st_mode)) {
 					if (recurse) {
 						/*
diff -Nurp '--exclude=.bzr*' tin-2.6.4/src/signal.c tin-2.6.5/src/signal.c
--- tin-2.6.4/src/signal.c	2024-11-25 20:40:37.000000000 +0100
+++ tin-2.6.5/src/signal.c	2025-12-16 19:59:36.572376264 +0100
@@ -3,10 +3,10 @@
  *  Module    : signal.c
  *  Author    : I.Lea
  *  Created   : 1991-04-01
- *  Updated   : 2024-11-21
+ *  Updated   : 2025-12-16
  *  Notes     : signal handlers for different modes and window resizing
  *
- * Copyright (c) 1991-2025 Iain Lea <iain@bricbrac.de>
+ * Copyright (c) 1991-2026 Iain Lea <iain@bricbrac.de>
  * All rights reserved.
  *
  * Redistribution and use in source and binary forms, with or without
@@ -104,9 +104,9 @@ static void _CDECL signal_handler(SIG_AR
 	static t_bool redraw_after_suspend;
 #endif /* SIGWINCH || SIGTSTP */
 
-int signal_context = cMain;
+enum context signal_context = cMain;
 int input_context = cNone;
-int need_parse_fmt;
+int need_parse_fmt = 0;
 int need_resize = cNo;
 /*
  * # lines of non-static data available for display
@@ -274,9 +274,7 @@ handle_resize(
 	my_retouch();
 #	endif /* USE_CURSES */
 
-	need_parse_fmt |= SELECT_LEVEL;
-	need_parse_fmt |= GROUP_LEVEL;
-	need_parse_fmt |= THREAD_LEVEL;
+	need_parse_fmt |= (SELECT_LEVEL|GROUP_LEVEL|THREAD_LEVEL);
 
 	switch (signal_context) {
 		case cArt:
@@ -309,7 +307,7 @@ handle_resize(
 			break;
 
 		case cPage:
-			resize_article(TRUE, &pgart);
+			resize_article(TRUE, &pgart); /* loses current state raw/cooked */
 			draw_page(0);
 			break;
 
@@ -340,7 +338,11 @@ handle_resize(
 
 	switch (input_context) {
 		case cGetline:
-			gl_redraw();
+			/* leave input field to avoid confusion after redrawing the screen */
+			if (signal_context == cAttrib || signal_context == cConfig)
+				pending_sactions = 1;
+			else
+				gl_redraw();
 			break;
 
 		case cPromptCONT:
@@ -348,6 +350,11 @@ handle_resize(
 				info_message(_(txt_return_key));
 			break;
 
+		case cPromptList:
+			/* leave input field to avoid confusion after redrawing the screen */
+			pending_sactions = 1;
+			break;
+
 		case cPromptSLK:
 			prompt_slk_redraw();
 			break;
@@ -443,13 +450,13 @@ signal_handler(
 			 * phase give the user a chance to go on instead of exiting
 			 */
 			if (signal_context == cReconnect || batch_mode || !use_compress || !nntp_caps.compress || prompt_yn(_(txt_read_timeout_quit), FALSE) == 1)
-				tin_done(NNTP_ERROR_EXIT, _(txt_connection_error));
+				tin_done(NNTP_ERROR_EXIT, _(txt_connection_error_timeout), TIN_NNTP_TIMEOUT); /* NOTE: a lot of signal-unsafe calls in tin_done() */
 			else {
 				RESTORE_HANDLER(sig, signal_handler);
 				my_fprintf(stdout, "%s", _(txt_continuing));
 			}
 #		else
-			tin_done(NNTP_ERROR_EXIT, _(txt_connection_error));
+			tin_done(NNTP_ERROR_EXIT, _(txt_connection_error_timeout), TIN_NNTP_TIMEOUT); /* NOTE: a lot of signal-unsafe calls in tin_done() */
 #		endif /* USE_ZLIB */
 #	endif /* NNTP_ABLE */
 			errno = serrno;
diff -Nurp '--exclude=.bzr*' tin-2.6.4/src/strftime.c tin-2.6.5/src/strftime.c
--- tin-2.6.4/src/strftime.c	2024-12-17 21:36:26.000000000 +0100
+++ tin-2.6.5/src/strftime.c	2025-11-13 02:21:32.668183834 +0100
@@ -14,7 +14,7 @@
  *              tm = localtime(&secs);
  *              num = strftime(buf, sizeof(buf), "%a %d-%m-%y %H:%M:%S", tm);
  *
- * Copyright (c) 1991-2025 Arnold Robbins <arnold@skeeve.com>
+ * Copyright (c) 1991-2026 Arnold Robbins <arnold@skeeve.com>
  * All rights reserved.
  *
  * Redistribution and use in source and binary forms, with or without
@@ -72,10 +72,6 @@ my_strftime(
 	char *start = s;
 	char tbuf[100];
 	int i;
-
-	/*
-	 * various tables, useful in North America
-	 */
 	static const char *days_a[] = {
 		"Sun", "Mon", "Tue", "Wed",
 		"Thu", "Fri", "Sat",
@@ -117,181 +113,181 @@ my_strftime(
 			continue;
 		}
 		switch (*++format) {
-		case '\0':
-			*s++ = '%';
-			goto out;
-
-		case '%':
-			*s++ = '%';
-			continue;
-
-		case 'a':	/* abbreviated weekday name */
-			strcpy(tbuf, days_a[timeptr->tm_wday]);
-			break;
-
-		case 'A':	/* full weekday name */
-			strcpy(tbuf, days_l[timeptr->tm_wday]);
-			break;
+			case '\0':
+				*s++ = '%';
+				goto out;
+
+			case '%':
+				*s++ = '%';
+				continue;
+
+			case 'a':	/* abbreviated weekday name */
+				strcpy(tbuf, days_a[timeptr->tm_wday]);
+				break;
+
+			case 'A':	/* full weekday name */
+				strcpy(tbuf, days_l[timeptr->tm_wday]);
+				break;
 
 #	ifdef SYSV_EXT
-		case 'h':	/* abbreviated month name */
+			case 'h':	/* abbreviated month name */
 #	endif /* SYSV_EXT */
-		case 'b':	/* abbreviated month name */
-			strcpy(tbuf, months_a[timeptr->tm_mon]);
-			break;
-
-		case 'B':	/* full month name */
-			strcpy(tbuf, months_l[timeptr->tm_mon]);
-			break;
-
-		case 'c':	/* appropriate date and time representation */
-			snprintf(tbuf, sizeof(tbuf), "%s %s %2d %02d:%02d:%02d %d",
-				days_a[timeptr->tm_wday],
-				months_a[timeptr->tm_mon],
-				timeptr->tm_mday,
-				timeptr->tm_hour,
-				timeptr->tm_min,
-				timeptr->tm_sec,
-				timeptr->tm_year + 1900);
-			break;
-
-		case 'd':	/* day of the month, 01 - 31 */
-			snprintf(tbuf, sizeof(tbuf), "%02d", timeptr->tm_mday);
-			break;
-
-		case 'H':	/* hour, 24-hour clock, 00 - 23 */
-			snprintf(tbuf, sizeof(tbuf), "%02d", timeptr->tm_hour);
-			break;
-
-		case 'I':	/* hour, 12-hour clock, 01 - 12 */
-			i = timeptr->tm_hour;
-			if (i == 0)
-				i = 12;
-			else if (i > 12)
-				i -= 12;
-			snprintf(tbuf, sizeof(tbuf), "%02d", i);
-			break;
-
-		case 'j':	/* day of the year, 001 - 366 */
-			snprintf(tbuf, sizeof(tbuf), "%03d", timeptr->tm_yday + 1);
-			break;
-
-		case 'm':	/* month, 01 - 12 */
-			snprintf(tbuf, sizeof(tbuf), "%02d", timeptr->tm_mon + 1);
-			break;
-
-		case 'M':	/* minute, 00 - 59 */
-			snprintf(tbuf, sizeof(tbuf), "%02d", timeptr->tm_min);
-			break;
-
-		case 'p':	/* AM or PM based on 12-hour clock */
-			strcpy(tbuf, ampm[((timeptr->tm_hour < 12) ? 0 : 1)]);
-			break;
-
-		case 'S':	/* second, 00 - 61 */
-			snprintf(tbuf, sizeof(tbuf), "%02d", timeptr->tm_sec);
-			break;
-
-		case 'w':	/* weekday, Sunday == 0, 0 - 6 */
-			snprintf(tbuf, sizeof(tbuf), "%d", timeptr->tm_wday);
-			break;
-
-		case 'x':	/* appropriate date representation */
-			snprintf(tbuf, sizeof(tbuf), "%s %s %2d %d",
-				days_a[timeptr->tm_wday],
-				months_a[timeptr->tm_mon],
-				timeptr->tm_mday,
-				timeptr->tm_year + 1900);
-			break;
-
-		case 'X':	/* appropriate time representation */
-			snprintf(tbuf, sizeof(tbuf), "%02d:%02d:%02d",
-				timeptr->tm_hour,
-				timeptr->tm_min,
-				timeptr->tm_sec);
-			break;
-
-		case 'y':	/* year without a century, 00 - 99 */
-			i = timeptr->tm_year % 100;
-			snprintf(tbuf, sizeof(tbuf), "%d", i);
-			break;
-
-		case 'Y':	/* year with century */
-			snprintf(tbuf, sizeof(tbuf), "%d", timeptr->tm_year + 1900);
-			break;
+			case 'b':	/* abbreviated month name */
+				strcpy(tbuf, months_a[timeptr->tm_mon]);
+				break;
+
+			case 'B':	/* full month name */
+				strcpy(tbuf, months_l[timeptr->tm_mon]);
+				break;
+
+			case 'c':	/* appropriate date and time representation */
+				snprintf(tbuf, sizeof(tbuf), "%s %s %2d %02d:%02d:%02d %d",
+					days_a[timeptr->tm_wday],
+					months_a[timeptr->tm_mon],
+					timeptr->tm_mday,
+					timeptr->tm_hour,
+					timeptr->tm_min,
+					timeptr->tm_sec,
+					timeptr->tm_year + 1900);
+				break;
+
+			case 'd':	/* day of the month, 01 - 31 */
+				snprintf(tbuf, sizeof(tbuf), "%02d", timeptr->tm_mday);
+				break;
+
+			case 'H':	/* hour, 24-hour clock, 00 - 23 */
+				snprintf(tbuf, sizeof(tbuf), "%02d", timeptr->tm_hour);
+				break;
+
+			case 'I':	/* hour, 12-hour clock, 01 - 12 */
+				i = timeptr->tm_hour;
+				if (i == 0)
+					i = 12;
+				else if (i > 12)
+					i -= 12;
+				snprintf(tbuf, sizeof(tbuf), "%02d", i);
+				break;
+
+			case 'j':	/* day of the year, 001 - 366 */
+				snprintf(tbuf, sizeof(tbuf), "%03d", timeptr->tm_yday + 1);
+				break;
+
+			case 'm':	/* month, 01 - 12 */
+				snprintf(tbuf, sizeof(tbuf), "%02d", timeptr->tm_mon + 1);
+				break;
+
+			case 'M':	/* minute, 00 - 59 */
+				snprintf(tbuf, sizeof(tbuf), "%02d", timeptr->tm_min);
+				break;
+
+			case 'p':	/* AM or PM based on 12-hour clock */
+				strcpy(tbuf, ampm[((timeptr->tm_hour < 12) ? 0 : 1)]);
+				break;
+
+			case 'S':	/* second, 00 - 61 */
+				snprintf(tbuf, sizeof(tbuf), "%02d", timeptr->tm_sec);
+				break;
+
+			case 'w':	/* weekday, Sunday == 0, 0 - 6 */
+				snprintf(tbuf, sizeof(tbuf), "%d", timeptr->tm_wday);
+				break;
+
+			case 'x':	/* appropriate date representation */
+				snprintf(tbuf, sizeof(tbuf), "%s %s %2d %d",
+					days_a[timeptr->tm_wday],
+					months_a[timeptr->tm_mon],
+					timeptr->tm_mday,
+					timeptr->tm_year + 1900);
+				break;
+
+			case 'X':	/* appropriate time representation */
+				snprintf(tbuf, sizeof(tbuf), "%02d:%02d:%02d",
+					timeptr->tm_hour,
+					timeptr->tm_min,
+					timeptr->tm_sec);
+				break;
+
+			case 'y':	/* year without a century, 00 - 99 */
+				i = timeptr->tm_year % 100;
+				snprintf(tbuf, sizeof(tbuf), "%d", i);
+				break;
+
+			case 'Y':	/* year with century */
+				snprintf(tbuf, sizeof(tbuf), "%d", timeptr->tm_year + 1900);
+				break;
 
 #	ifdef SYSV_EXT
-		case 'n':	/* same as \n */
-			tbuf[0] = '\n';
-			tbuf[1] = '\0';
-			break;
-
-		case 't':	/* same as \t */
-			tbuf[0] = '\t';
-			tbuf[1] = '\0';
-			break;
-
-		case 'D':	/* date as %m/%d/%y */
-			my_strftime(tbuf, sizeof(tbuf), "%m/%d/%y", timeptr);
-			break;
-
-		case 'e':	/* day of month, blank padded */
-			snprintf(tbuf, sizeof(tbuf), "%2d", timeptr->tm_mday);
-			break;
-
-		case 'r':	/* time as %I:%M:%S %p */
-			my_strftime(tbuf, sizeof(tbuf), "%I:%M:%S %p", timeptr);
-			break;
-
-		case 'R':	/* time as %H:%M */
-			my_strftime(tbuf, sizeof(tbuf), "%H:%M", timeptr);
-			break;
-
-		case 'T':	/* time as %H:%M:%S */
-			my_strftime(tbuf, sizeof(tbuf), "%H:%M:%S", timeptr);
-			break;
+			case 'n':	/* same as \n */
+				tbuf[0] = '\n';
+				tbuf[1] = '\0';
+				break;
+
+			case 't':	/* same as \t */
+				tbuf[0] = '\t';
+				tbuf[1] = '\0';
+				break;
+
+			case 'D':	/* date as %m/%d/%y */
+				my_strftime(tbuf, sizeof(tbuf), "%m/%d/%y", timeptr);
+				break;
+
+			case 'e':	/* day of month, blank padded */
+				snprintf(tbuf, sizeof(tbuf), "%2d", timeptr->tm_mday);
+				break;
+
+			case 'r':	/* time as %I:%M:%S %p */
+				my_strftime(tbuf, sizeof(tbuf), "%I:%M:%S %p", timeptr);
+				break;
+
+			case 'R':	/* time as %H:%M */
+				my_strftime(tbuf, sizeof(tbuf), "%H:%M", timeptr);
+				break;
+
+			case 'T':	/* time as %H:%M:%S */
+				my_strftime(tbuf, sizeof(tbuf), "%H:%M:%S", timeptr);
+				break;
 #	endif /* SYSV_EXT */
 
-		case 'C': /* century number (SU) */
-			sprintf(tbuf, "%02d", (timeptr->tm_year + 1900) / 100);
-			break;
-
-		case 'F': /* ISO 8601 date format (C99) */
-			my_strftime(tbuf, sizeof(tbuf), "%Y-%m-%d", timeptr);
-			break;
-
-		case 'k':	/* 24-hour clock, blank padded */
-			snprintf(tbuf, sizeof(tbuf), "%2d", timeptr->tm_hour);
-			break;
-
-		case 'l':	/* 12-hour clock, blank padded */
-			i = timeptr->tm_hour;
-			if (i == 0)
-				i = 12;
-			else if (i > 12)
-				i -=12;
-			snprintf(tbuf, sizeof(tbuf), "%2d", i);
-			break;
-
-		case 'P':	/* am or pm based on 12-hour clock (GNU) */
-			strcpy(tbuf, ampm[((timeptr->tm_hour < 12) ? 0 : 1)]);
-			str_lwr(tbuf);
-			break;
-
-		case 's': /* seconds since the Epoch */
-			sprintf(tbuf, "%ld", time((time_t *) 0));
-			break;
-
-		case 'u': /* day of the week, range 1 to 7 */
-			sprintf(tbuf, "%d", timeptr->tm_wday == 0 ? 7 : timeptr->tm_wday);
-			break;
-
-		default:
-			tbuf[0] = '%';
-			tbuf[1] = *format;
-			tbuf[2] = '\0';
-			break;
+			case 'C': /* century number (SU) */
+				sprintf(tbuf, "%02d", (timeptr->tm_year + 1900) / 100);
+				break;
+
+			case 'F': /* ISO 8601 date format (C99) */
+				my_strftime(tbuf, sizeof(tbuf), "%Y-%m-%d", timeptr);
+				break;
+
+			case 'k':	/* 24-hour clock, blank padded */
+				snprintf(tbuf, sizeof(tbuf), "%2d", timeptr->tm_hour);
+				break;
+
+			case 'l':	/* 12-hour clock, blank padded */
+				if ((i = timeptr->tm_hour) == 0)
+					i = 12;
+				else if (i > 12)
+					i -= 12;
+				snprintf(tbuf, sizeof(tbuf), "%2d", i);
+				break;
+
+			case 'P':	/* am or pm based on 12-hour clock (GNU) */
+				strcpy(tbuf, ampm[((timeptr->tm_hour < 12) ? 0 : 1)]);
+				str_lwr(tbuf);
+				break;
+
+			case 's': /* seconds since the Epoch */
+				sprintf(tbuf, "%ld", time((time_t *) 0));
+				break;
+
+			case 'u': /* day of the week, range 1 to 7 */
+				sprintf(tbuf, "%d", timeptr->tm_wday == 0 ? 7 : timeptr->tm_wday);
+				break;
+
+			default:
+				tbuf[0] = '%';
+				tbuf[1] = *format;
+				tbuf[2] = '\0';
+				break;
 		}
+
 		if ((i = strlen(tbuf))) {
 			if (s + i < endp - 1) {
 				strcpy(s, tbuf);
diff -Nurp '--exclude=.bzr*' tin-2.6.4/src/string.c tin-2.6.5/src/string.c
--- tin-2.6.4/src/string.c	2024-12-18 14:49:47.000000000 +0100
+++ tin-2.6.5/src/string.c	2025-12-08 00:36:28.114774602 +0100
@@ -3,10 +3,10 @@
  *  Module    : string.c
  *  Author    : Urs Janssen <urs@tin.org>
  *  Created   : 1997-01-20
- *  Updated   : 2024-12-18
+ *  Updated   : 2025-12-05
  *  Notes     :
  *
- * Copyright (c) 1997-2025 Urs Janssen <urs@tin.org>
+ * Copyright (c) 1997-2026 Urs Janssen <urs@tin.org>
  * All rights reserved.
  *
  * Redistribution and use in source and binary forms, with or without
@@ -60,6 +60,13 @@
 /*
  * this file needs some work
  */
+/*
+ * Local prototypes
+ */
+#if defined(MULTIBYTE_ABLE) && !defined(NO_LOCALE)
+	static wchar_t *my_wcsdup(const wchar_t *wstr);
+	static wchar_t *wexpand_tab(const wchar_t *wstr, size_t tab_width);
+#endif /* MULTIBYTE_ABLE && !NO_LOCALE */
 
 
 /*
@@ -331,6 +338,29 @@ str_lwr(
 
 
 /*
+ * TODO: add a wide char variant "wchar *wstr_upr(wchar *wc)" or
+ * HAVE_LIBICUUC
+ * 	char *dst = NULL; UChar *usrc, *udst;
+ * 	UErrorCode err = U_ZERO_ERROR; size_t dlen;
+ * 	dlen = (strlen(src) + 1) * 4; udst = my_malloc(dlen);
+ * 	usrc = char2UChar(src); u_strToUpper(udst, dlen, usrc, -1, NULL, &err);
+ * 	if (!(U_FAILURE(err))) dst = UChar2char(udst);
+ * 	free(udst); return dst;
+ */
+void
+str_upr(
+	char *str)
+{
+	char *dst = str;
+
+	while (*str)
+		*dst++ = (char) my_toupper((unsigned char) *str++);
+
+	*dst = '\0';
+}
+
+
+/*
  * normal systems come with these...
  */
 
@@ -416,7 +446,8 @@ strstr(
 #endif /* !HAVE_STRSTR */
 
 
-#ifndef HAVE_ATOL /* unused except in atoartnum-marco */
+#if !defined(USE_LONG_ARTICLE_NUMBERS) && !defined(HAVE_ATOL)
+/* unused except in atoartnum-marco */
 /*
  * handrolled atol
  */
@@ -424,7 +455,7 @@ long
 atol(
 	const char *s)
 {
-	long ret = 0;
+	long ret = 0L;
 
 	/* skip leading whitespace(s) */
 	while (*s && isspace((unsigned char) *s))
@@ -439,7 +470,7 @@ atol(
 	}
 	return ret;
 }
-#endif /* !HAVE_ATOL */
+#endif /* !USE_LONG_ARTICLE_NUMBERS && !HAVE_ATOL */
 
 
 #ifndef HAVE_STRTOL
@@ -479,9 +510,10 @@ strtol(
 				use_base = 8;
 		} else
 			use_base = 10;
-	} else if (use_base == 16)
+	} else if (use_base == 16) {
 		if (str[0] == '0' && (str[1] == 'x' || str[1] == 'X'))
 			str += 2;
+	}
 	/*
 	 * for any base > 10, the digits incrementally following
 	 * 9 are assumed to be "abc...z" or "ABC...Z"
@@ -640,7 +672,7 @@ eat_tab(
 
 
 #if defined(MULTIBYTE_ABLE) && !defined(NO_LOCALE)
-wchar_t *
+static wchar_t *
 wexpand_tab(
 	const wchar_t *wstr,
 	size_t tab_width)
@@ -872,26 +904,49 @@ wchar_t *
 char2wchar_t(
 	const char *str)
 {
-	char *test = my_strdup(str);
-	size_t len = (size_t) (-1);
-	size_t pos = strlen(test);
+	char *test;
+	size_t i, len, pos;
 	wchar_t *wstr;
 
+	if (!str)
+		return NULL;
+
+	test = my_calloc(1, strlen(str) + 1);
 	/* check for illegal sequences */
-	while (len == (size_t) (-1) && pos) {
+	for (pos = 0; str[pos] != '\0'; pos++) {
+		test[pos] = str[pos];
+		i = 1;
+		while ((len = mbstowcs(NULL, test, 0)) == (size_t) (-1) && str[pos + i] != '\0' && i < (size_t) MB_CUR_MAX) {
+			test[pos + i] = str[pos + i];
+			i++;
+		}
+		if (len == (size_t) (-1)) {
+			test[pos] = '?';
+			while (--i > 1)
+				test[pos + i] = '\0';
+		} else
+			pos += i - 1;
+		test[pos + 1] = '\0';
+	}
+
+#if 0
+	if ((len = mbstowcs(NULL, test, 0)) != pos) {
+		len = (size_t) (-1);
+		while (len == (size_t) (-1) && pos) {
 		if ((len = mbstowcs(NULL, test, 0)) == (size_t) (-1))
 			test[--pos] = '?';
+		}
 	}
-	/* shouldn't happen anymore */
-	if (len == (size_t) (-1)) {
+#endif /* 0 */
+
+	if ((len = mbstowcs(NULL, test, 0)) == (size_t) (-1)) {
 		free(test);
 		return NULL;
 	}
 
-	/* if ((len = mbstowcs(NULL, test, 0) == (size_t) (-1)) { free(test); return NULL; } */
 	wstr = my_calloc(len + 1, sizeof(wchar_t));
-	/* pos = */ mbstowcs(wstr, test, len);
-	/* wstr[pos == (size_t) (-1) ? 0 : pos] = '\0'; */
+	pos = mbstowcs(wstr, test, len);
+	wstr[pos == (size_t) (-1) ? 0 : pos] = '\0';
 	free(test);
 
 	return wstr;
@@ -1050,9 +1105,9 @@ abbr_groupname(
 	char *src, *dest, *tail, *new_grpname;
 	size_t tmplen, newlen;
 
-	dest = new_grpname = my_strdup(grpname);
+	dest = new_grpname = my_strdup(len > 0 ? grpname : "");
 
-	if (strlen(grpname) > len) {
+	if (len > 0 && strlen(grpname) > len) {
 		if ((src = strchr(grpname, '.')) != NULL) {
 			++dest;
 			tmplen = 1;
@@ -1119,6 +1174,8 @@ strwidth(
  * If it was necessary to truncate 'mesg', " ..." is appended to the
  * resulting string (still 'len' screen positions wide).
  * The resulting string is stored in 'buf'.
+ *
+ * TODO: stop at first '\n' and remove (leading?) and tailing whitespace.
  */
 char *
 strunc(
@@ -1126,6 +1183,7 @@ strunc(
 	size_t len)
 {
 	char *tmp;
+	size_t tlen = strlen(TRUNC_TAIL);
 #if defined(MULTIBYTE_ABLE) && !defined(NO_LOCALE)
 	wchar_t *wmessage, *wbuf;
 
@@ -1143,11 +1201,22 @@ strunc(
 	/* something went wrong using wide-chars, default back to normal chars */
 #endif /* MULTIBYTE_ABLE && !NO_LOCALE */
 
-	if (strlen(BlankIfNull(message)) <= len)
-		tmp = my_strdup(BlankIfNull(message));
+	if (len <= tlen)
+		tmp = my_strdup("");
 	else {
-		tmp = my_malloc(len + 1);
-		snprintf(tmp, len + 1, "%-.*s%s", (int) (len - 3), message, TRUNC_TAIL);
+		char *tmp_msg;
+
+		tmp_msg = my_strdup(message);
+		/* make sure all characters are printable */
+		convert_to_printable(tmp_msg, FALSE);
+
+		if (strlen(tmp_msg) <= len)
+			tmp = my_strdup(tmp_msg);
+		else {
+			tmp = my_malloc(len + 1);
+			snprintf(tmp, len + 1, "%-*.*s%s", (int) (len - tlen), (int) (len - tlen), tmp_msg, TRUNC_TAIL);
+		}
+		free(tmp_msg);
 	}
 
 	return tmp;
@@ -1156,6 +1225,7 @@ strunc(
 
 #if defined(MULTIBYTE_ABLE) && !defined(NO_LOCALE)
 /* the wide-char equivalent of strunc() */
+/* TODO: stop at first '\n' and remove (leading?) and tailing whitespace. */
 wchar_t *
 wstrunc(
 	const wchar_t *wmessage,
@@ -1170,7 +1240,7 @@ wstrunc(
 	if (wcswidth(wtmp, wcslen(wtmp)) > (int) len) {
 		/* wtmp must be truncated */
 		size_t len_tail;
-		wchar_t *wtmp2, *tail;
+		wchar_t *wtmp2 = NULL, *tail;
 
 		if (tinrc.utf8_graphics)
 			tail = my_wcsdup((const wchar_t *) WTRUNC_TAIL);
@@ -1178,13 +1248,13 @@ wstrunc(
 			tail = char2wchar_t(TRUNC_TAIL);
 
 		len_tail = tail ? wcslen(tail) : 0;
-		if (len_tail > len) {
+		if (len_tail >= len) {
 			FreeAndNull(tail);
 			len_tail = 0;
-		}
-		wtmp2 = wcspart(wtmp, len - len_tail, FALSE);
-		free(wtmp);
+		} else
+			wtmp2 = wcspart(wtmp, len - len_tail, FALSE);
 
+		free(wtmp);
 		if (wtmp2)
 			wtmp = my_realloc(wtmp2, sizeof(wchar_t) * (wcslen(wtmp2) + len_tail + 1));	/* wtmp2 isn't valid anymore and doesn't have to be free()ed */
 		else
@@ -1203,7 +1273,7 @@ wstrunc(
 /*
  * duplicates a wide-char string
  */
-wchar_t *
+static wchar_t *
 my_wcsdup(
 	const wchar_t *wstr)
 {
@@ -1576,34 +1646,34 @@ parse_format_string(
 		tmp_date_str[0] = '\0';
 		d_fmt = tmp_date_str;
 		if (*in > '0' && *in <= '9') {
-			len = (size_t) atoi(in);
+			len = (size_t) strtol(in, NULL, 10);
 			for (; *in >= '0' && *in <= '9'; in++)
 				;
 		}
 		if (*in == ',') {
 			if (*++in > '0' && *in <= '9') {
-				len2 = (size_t) atoi(in);
+				len2 = (size_t) strtol(in, NULL, 10);
 				for (; *in >= '0' && *in <= '9'; in++)
 					;
 			}
 		}
 		if (*in == '>') {
 			if (*++in > '0' && *in <= '9') {
-				min_cols = atoi(in);
+				min_cols = strtol(in, NULL, 10);
 				for (; *in >= '0' && *in <= '9'; in++)
 					;
 			}
 		}
 		if (*in == '<') {
 			if (*++in > '0' && *in <= '9') {
-				max_cols = atoi(in);
+				max_cols = strtol(in, NULL, 10);
 				for (; *in >= '0' && *in <= '9'; in++)
 					;
 			}
 		}
 		if (*in == ':') {
 			if (*++in > '0' && *in <= '9') {
-				cond_len = atoi(in);
+				cond_len = strtol(in, NULL, 10);
 				for (; *in >= '0' && *in <= '9'; in++)
 					;
 			} else
@@ -1743,7 +1813,11 @@ parse_format_string(
 				/* Article marks */
 				if ((cCOLS > min_cols && cCOLS < max_cols) && !(flags & ART_MARKS) && (signal_context == cGroup || signal_context == cThread)) {
 					flags |= ART_MARKS;
+#if defined(MULTIBYTE_ABLE) && !defined(NO_LOCALE)
 					cnt += (art_mark_width + 2);
+#else
+					cnt += 3;
+#endif /* MULTIBYTE_ABLE && !NO_LOCALE */
 				} else
 					out -= 2;
 				break;
@@ -1970,13 +2044,15 @@ parse_format_string(
 				}
 			}
 		} else if (flags_last && (!*len_first || *len_first > (size_t) len_tmp))
-				*len_first = (size_t) len_tmp;
+			*len_first = (size_t) len_tmp;
 	}
 }
 
 
 #if defined(HAVE_LIBICUUC) && defined(MULTIBYTE_ABLE) && defined(HAVE_UNICODE_UBIDI_H) && !defined(NO_LOCALE)
 /*
+ * TODO: this is way to simple and needs to be reworked
+ *
  * prepare a string with bi-directional text for display
  * (converts from logical order to visual order)
  *
@@ -2019,7 +2095,7 @@ render_bidi(
 
 	ustr_len = u_strlen(ustr) + 1;
 	ustr_reordered = my_malloc(sizeof(UChar) * ustr_len);
-	ubidi_writeReordered(bidi_data, ustr_reordered, ustr_len, UBIDI_REMOVE_BIDI_CONTROLS|UBIDI_DO_MIRRORING, &status);
+	ubidi_writeReordered(bidi_data, ustr_reordered, ustr_len, UBIDI_REMOVE_BIDI_CONTROLS|UBIDI_DO_MIRRORING, &status); /* UBIDI_KEEP_BASE_COMBINING ? */
 	if (U_FAILURE(status)) {
 		ubidi_close(bidi_data);
 		free(ustr);
@@ -2060,11 +2136,12 @@ s2i(
 	signed int max)
 {
 	const char *hex;
-	char *end;
+	char *end = NULL;
 	signed long res;
 
 	errno = 0;
 
+	/* allow 0[xX]n for hex, leading 0 is required */
 	if ((hex = strpbrk(s, "xX")) != NULL && hex > s && *(hex - 1) == '0')
 		res = strtol(s, &end, 16);
 	else
@@ -2080,7 +2157,7 @@ s2i(
 		errno = ERANGE;
 	}
 
-	if (s == end) {
+	if (s == end || min > max) {
 		res = 0;
 		errno = EINVAL;
 	}
diff -Nurp '--exclude=.bzr*' tin-2.6.4/src/tags.c tin-2.6.5/src/tags.c
--- tin-2.6.4/src/tags.c	2024-11-25 20:40:37.000000000 +0100
+++ tin-2.6.5/src/tags.c	2025-11-13 02:21:32.680184358 +0100
@@ -3,10 +3,10 @@
  *  Module    : tags.c
  *  Author    : Jason Faultless <jason@altarstone.com>
  *  Created   : 1999-12-06
- *  Updated   : 2024-11-25
+ *  Updated   : 2025-03-16
  *  Notes     : Split out from other modules
  *
- * Copyright (c) 1999-2025 Jason Faultless <jason@altarstone.com>
+ * Copyright (c) 1999-2026 Jason Faultless <jason@altarstone.com>
  * All rights reserved.
  *
  * Redistribution and use in source and binary forms, with or without
@@ -42,7 +42,7 @@
 #endif /* !TIN_H */
 
 /* Local prototypes */
-static t_bool parse_range(char *range, int min, int max, int curr, int *range_start, int *range_end);
+static t_bool parse_range(const char *range, int min, int max, int curr, int *range_start, int *range_end);
 
 int num_of_tagged_arts = 0;
 
@@ -139,11 +139,11 @@ tag_article(
 {
 	if (arts[art].tagged != 0) {
 		untag_article(art);
-		info_message(_(txt_prefix_untagged), txt_article_singular);
+		info_message(_(txt_untagged_article));
 		return FALSE;
 	} else {
 		arts[art].tagged = ++num_of_tagged_arts;
-		info_message(_(txt_prefix_tagged), txt_article_singular);
+		info_message(_(txt_tagged_article_sp[0]));
 		return TRUE;
 	}
 }
@@ -326,14 +326,14 @@ set_range(
  */
 static t_bool
 parse_range(
-	char *range,
+	const char *range,
 	int min,
 	int max,
 	int curr,
 	int *range_start,
 	int *range_end)
 {
-	char *ptr = range;
+	const char *ptr = range;
 	enum states { FINDMIN, FINDMAX, DONE };
 	int state = FINDMIN;
 	t_bool ret = FALSE;
@@ -344,10 +344,10 @@ parse_range(
 	while (*ptr && state != DONE) {
 		if (isdigit((unsigned char) *ptr)) {
 			if (state == FINDMAX) {
-				*range_end = atoi(ptr);
+				*range_end = strtol(ptr, NULL, 10);
 				state = DONE;
 			} else
-				*range_start = atoi(ptr);
+				*range_start = strtol(ptr, NULL, 10);
 			while (isdigit((unsigned char) *ptr))
 				++ptr;
 		} else {
diff -Nurp '--exclude=.bzr*' tin-2.6.4/src/tcurses.c tin-2.6.5/src/tcurses.c
--- tin-2.6.4/src/tcurses.c	2024-12-03 04:06:01.000000000 +0100
+++ tin-2.6.5/src/tcurses.c	2025-11-13 02:21:32.684184532 +0100
@@ -3,11 +3,11 @@
  *  Module    : tcurses.c
  *  Author    : Thomas Dickey <dickey@invisible-island.net>
  *  Created   : 1997-03-02
- *  Updated   : 2024-08-15
+ *  Updated   : 2025-10-05
  *  Notes     : This is a set of wrapper functions adapting the termcap
  *	             interface of tin to use SVr4 curses (e.g., ncurses).
  *
- * Copyright (c) 1997-2025 Thomas Dickey <dickey@invisible-island.net>
+ * Copyright (c) 1997-2026 Thomas Dickey <dickey@invisible-island.net>
  * All rights reserved.
  *
  * Redistribution and use in source and binary forms, with or without
@@ -220,7 +220,7 @@ StartInverse(
 {
 	if (tinrc.inverse_okay) {
 #	ifdef HAVE_COLOR
-		if (use_color) {
+		if (use_color && (tinrc.col_invers_bg != -1 || tinrc.col_invers_fg != -1)) {
 			bcol(tinrc.col_invers_bg);
 			fcol(tinrc.col_invers_fg);
 		} else
@@ -467,10 +467,8 @@ word_highlight_string(
 #		endif /* MULTIBYTE_ABLE && !NO_LOCALE */
 
 	/* safegurad against bogus regexps */
-	if (size > 1 && ((tmp[0] == '*' && tmp[size - 1] == '*') ||
-		 (tmp[0] == '/' && tmp[size - 1] == '/') ||
-		 (tmp[0] == '_' && tmp[size - 1] == '_') ||
-		 (tmp[0] == '-' && tmp[size - 1] == '-'))) {
+	if (size > 1 && tmp[size - 1] == tmp[0] &&
+		(tmp[0] == '*' || tmp[0] == '/' || tmp[0] == '_' || tmp[0] == '-')) {
 
 		switch (tinrc.word_h_display_marks) {
 			case 0:
